<template>
  <div class="tenant">
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        :selectConfig="selectConfig"
        highlight-current-row
        :action-list="[
          {
            text: '创建合同',
            action: () => newContract(),
          },
        ]"
        @get-list="getList">
        <template #amount="{ item }">
          <div>
            <span style="padding-right: 4px">{{ item.currency }}</span>
            <span>{{ moneyFormat(item.amount, 2) }}</span>
          </div>
        </template>
        <template #refundMoney="{ item }">
          <div>
            <span style="padding-right: 4px">{{ item.currency }}</span>
            <span>{{ moneyFormat(item.refundMoney, 2) }}</span>
          </div>
        </template>
        <template #advanceRatio="{ item }">
          <div>
            <span>{{ item.advanceRatio }}%</span>
          </div>
        </template>
      </byTable>
    </div>

    <el-dialog title="打印" v-if="openPrint" v-model="openPrint" width="860">
      <div id="pdfDom" style="width: 800px; padding: 16px; font-size: 12px !important">
        <div style="font-size: 18px; text-align: center">
          {{ printDetails.sellCorporationNameEn }}
        </div>
        <div style="text-align: center">
          {{ printDetails.sellCountryName }},{{ printDetails.sellProvinceName }},{{ printDetails.sellCityName }},{{ printDetails.sellDetailedAddress }}
        </div>
        <div style="font-size: 14px; color: #409eff; text-align: center; padding-top: 16px">PROFORMA INVOICE</div>
        <div style="padding-top: 8px">
          <div>PI NO. : {{ printDetails.contractCode }}</div>
          <div>PI DATE: {{ printDetails.createTimeEn }}</div>
        </div>
        <div style="border: 1px solid black; display: flex">
          <div style="width: 50%; border-right: 1px solid black">
            <div style="color: #409eff">VENDOR:</div>
            <div>{{ printDetails.sellCorporationNameEn }}</div>
            <div style="padding: 16px 0">
              {{ printDetails.sellCountryName }},{{ printDetails.sellProvinceName }},{{ printDetails.sellCityName }},{{ printDetails.sellDetailedAddress }}
            </div>
            <div>CONTACT: {{ printDetails.sellContactName }}</div>
            <div>TEL.: {{ printDetails.sellContactNumber }}</div>
          </div>
          <div style="width: 50%">
            <div style="color: #409eff">BUYER:</div>
            <div>{{ printDetails.buyCorporationName }}</div>
            <div style="padding: 16px 0">
              {{ printDetails.buyDetailedAddress }},{{ printDetails.buyCityName }},{{ printDetails.buyProvinceName }},{{ printDetails.buyCountryName }}
            </div>
            <div>CONTACT: {{ printDetails.buyContactName }}</div>
            <div>TEL.: {{ printDetails.buyContactNumber }}</div>
          </div>
        </div>
        <div style="height: 16px"></div>
        <div style="border: 1px solid black">
          <div style="display: flex; width: 100%">
            <div style="width: 33%; border-bottom: 1px solid black; border-right: 1px solid black">
              <div style="color: #409eff">COUNTRY OF ORIGIN:</div>
              <div>{{ printDetails.sellCountryName }}</div>
            </div>
            <div style="width: 34%; border-bottom: 1px solid black; border-right: 1px solid black">
              <div style="color: #409eff">COUNTRY OF DESTINATION:</div>
              <div>{{ printDetails.buyCountryName }}</div>
            </div>
            <div style="width: 33%; border-bottom: 1px solid black">
              <div style="color: #409eff">PLACE OF DISCHARGE:</div>
              <div>{{ printDetails.transportRemark }}</div>
            </div>
          </div>
          <div style="display: flex; width: 100%">
            <div style="width: 33%; border-bottom: 1px solid black; border-right: 1px solid black">
              <div style="color: #409eff">TERMS OF DELIVERY:</div>
              <div>
                {{ dictValueLabel(printDetails.tradeMethods, tradeMethods) }}
              </div>
            </div>
            <div style="width: 34%; border-bottom: 1px solid black; border-right: 1px solid black">
              <div style="color: #409eff">CURRENCY:</div>
              <div>
                {{ printDetails.currency }}
              </div>
            </div>
            <div style="width: 33%; border-bottom: 1px solid black">
              <div style="color: #409eff">EXPORT BY/VIA:</div>
              <div>
                {{ dictValueLabel(printDetails.transportMethod, shippingMethod) }}
              </div>
            </div>
          </div>
          <div style="display: flex; width: 100%">
            <div style="width: 33%; border-right: 1px solid black">
              <div style="color: #409eff">DELIVERY TIME:</div>
              <div>{{ printDetails.deliveryTime }}</div>
            </div>
            <div style="width: 67%">
              <div style="color: #409eff">TERMS OF PAYMENT:</div>
              <div>{{ printDetails.remark }}</div>
            </div>
          </div>
        </div>
        <div style="height: 16px"></div>
        <div class="baseRow" style="display: flex; color: #409eff">
          <div class="contentRow" style="width: 50px; text-align: center">NO.</div>
          <div class="contentRow" style="width: calc(100% - 450px); text-align: center">COMMODITY, SPECIFICATION</div>
          <div class="contentRow" style="width: 100px; text-align: center">UNIT</div>
          <div class="contentRow" style="width: 100px; text-align: center">QUANTITY</div>
          <div class="contentRow" style="width: 100px; text-align: center">UNIT PRICE</div>
          <div class="contentRow" style="width: 100px; text-align: center">TOTAL PRICE</div>
        </div>
        <div v-if="printDetails.productInfoList && printDetails.productInfoList.length > 0">
          <div class="baseRow" style="display: flex" v-for="(item, index) in printDetails.productInfoList" :key="item.productId">
            <div class="contentRow" style="width: 50px; text-align: center">
              {{ index + 1 }}
            </div>
            <div class="contentRow" style="width: calc(100% - 450px); text-align: center">
              {{ item.productName }}
            </div>
            <div class="contentRow" style="width: 100px; text-align: center">
              {{ item.productUnit }}
            </div>
            <div class="contentRow" style="width: 100px; text-align: center">
              {{ item.productQuantity }}
            </div>
            <div class="contentRow" style="width: 100px; text-align: center">
              {{ item.productPrice }}
            </div>
            <div class="contentRow" style="width: 100px; text-align: center">
              {{ item.amount }}
            </div>
          </div>
        </div>
        <div class="baseRow" style="display: flex; color: #409eff">
          <div class="contentRow" style="width: calc(100% - 400px); text-align: center">SUBTOTAL:</div>
          <div class="contentRow" style="width: 100px; text-align: center"></div>
          <div class="contentRow" style="width: 100px; text-align: center">
            {{ statistics("productQuantity", 0) }}
          </div>
          <div class="contentRow" style="width: 100px; text-align: center"></div>
          <div class="contentRow" style="width: 100px; text-align: center">
            {{ statistics("amount", 2) }}
          </div>
        </div>
        <!-- <div v-if="printDetails.quotationPayList && printDetails.quotationPayList.length > 0">
          <div class="baseRow" style="display: flex" v-for="(item, index) in printDetails.quotationPayList" :key="index">
            <div class="contentRow" style="width: calc(100% - 100px); text-align: right; color: #409eff">{{ item.payName }}:</div>
            <div class="contentRow" style="width: 100px; text-align: center">{{ item.amount }}</div>
          </div>
        </div> -->
        <div class="baseRow" style="display: flex">
          <div class="contentRow" style="width: calc(100% - 100px); text-align: right; color: #409eff">FREIGHT COST:</div>
          <div class="contentRow" style="width: 100px; text-align: center">
            {{ statisticsTwo("amount", 2) }}
          </div>
        </div>
        <div class="baseRow" style="display: flex">
          <div class="contentRow" style="width: calc(100% - 100px); text-align: right; color: #409eff">TOTAL PRICE:</div>
          <div class="contentRow" style="width: 100px; text-align: center">
            {{ printDetails.totalAmount }}
          </div>
        </div>
        <div class="baseRow" style="display: flex; border-bottom: 1px solid black">
          <div class="contentRow" style="width: 100%">
            {{ translateIntoEnglish(printDetails.totalAmount, printDetails.currency) }}
          </div>
        </div>
        <div style="height: 16px"></div>
        <div class="baseRow" style="color: #409eff">
          <div class="contentRow" style="width: 100%">ACCOUNT INFORMATION:</div>
        </div>
        <div class="baseRow" style="border-bottom: 1px solid black">
          <div class="contentRow" style="width: 100%">
            <div style="line-height: 24px; padding-left: 4px; word-break: break-all; word-wrap: break-word">
              Beneficiary Name: {{ printDetails.beneficiaryName }}
            </div>
            <div style="line-height: 24px; padding-left: 4px; word-break: break-all; word-wrap: break-word">
              Beneficiary Bank: {{ printDetails.beneficiaryBank }}
            </div>
            <div style="line-height: 24px; padding-left: 4px; word-break: break-all; word-wrap: break-word">
              Beneficiary Bank Address: {{ printDetails.beneficiaryBankAddress }}
            </div>
            <div style="line-height: 24px; padding-left: 4px; word-break: break-all; word-wrap: break-word">
              Beneficiary Account Number: {{ printDetails.beneficiaryAccountNumber }}
            </div>
            <div style="line-height: 24px; padding-left: 4px; word-break: break-all; word-wrap: break-word">Swift Code: {{ printDetails.swiftCode }}</div>
            <div style="line-height: 24px; padding-left: 4px; word-break: break-all; word-wrap: break-word">
              Beneficiary Address: {{ printDetails.beneficiaryAddress }}
            </div>
          </div>
        </div>
        <div style="height: 32px"></div>
        <div style="display: flex">
          <div style="width: 50%">
            <div style="color: #409eff">CONFIRMED BY VENDOR:</div>
            <div>{{ printDetails.sellCorporationNameEn }}</div>
          </div>
          <div style="width: 50%">
            <div style="color: #409eff">CONFIRMED BY BUYER:</div>
            <div>{{ printDetails.buyCorporationName }}</div>
          </div>
        </div>
      </div>
      <template #footer>
        <el-button @click="openPrint = false" size="large">取消</el-button>
        <el-button type="primary" @click="clickDownload()" size="large">下载PDF</el-button>
      </template>
    </el-dialog>
  </div>
</template>

<script setup>
import { computed, ref } from "vue";
import byTable from "@/components/byTable/index";
import useUserStore from "@/store/modules/user";
import { ElMessage, ElMessageBox } from "element-plus";

const { proxy } = getCurrentInstance();
const contractType = ref([]);
const accountCurrency = ref([]);
const tradeMethods = ref([]);
const corporationList = ref([]);
const customerList = ref([]);
const shippingMethod = ref([]);
const userList = ref([]);
const status = ref([
  {
    label: "草稿",
    value: 0,
  },
  {
    label: "审批中",
    value: 10,
  },
  {
    label: "驳回",
    value: 20,
  },
  {
    label: "审批通过",
    value: 30,
  },
  {
    label: "终止",
    value: 99,
  },
]);
const refundStatusNew = ref([
  {
    label: "未到款",
    value: 0,
  },
  {
    label: "部分到款",
    value: 10,
  },
  {
    label: "已到款",
    value: 20,
  },
]);
const sourceList = ref({
  data: [],
  pagination: {
    total: 0,
    pageNum: 1,
    pageSize: 10,
    keyword: "",
    status: "",
    sellCorporationId: "",
  },
});
const loading = ref(false);
const selectConfig = computed(() => {
  return [
    {
      label: "审批状态",
      prop: "status",
      data: status.value,
    },
    {
      label: "到款状态",
      prop: "refundStatusNew",
      data: refundStatusNew.value,
    },
    // {
    //   label: "归属公司",
    //   prop: "sellCorporationId",
    //   data: corporationList.value,
    // },
  ];
});
const config = computed(() => {
  return [
    {
      attrs: {
        label: "归属公司",
        prop: "sellCorporationId",
        "min-width": 220,
      },
      render(type) {
        let text = "";
        if (corporationList.value && corporationList.value.length > 0) {
          let data = corporationList.value.filter((item) => item.value == type);
          if (data && data.length > 0) {
            text = data[0].label;
          }
        }
        return text;
      },
    },
    {
      attrs: {
        label: "合同类型",
        prop: "contractType",
        width: 120,
      },
      render(type) {
        let text = "";
        if (contractType.value && contractType.value.length > 0) {
          let data = contractType.value.filter((item) => item.value == type);
          if (data && data.length > 0) {
            text = data[0].label;
          }
        }
        return text;
      },
    },
    {
      attrs: {
        label: "合同编码",
        prop: "code",
        width: 180,
      },
    },
    {
      attrs: {
        label: "客户",
        prop: "buyCorporationId",
        "min-width": 220,
      },
      render(type) {
        let text = "";
        if (customerList.value && customerList.value.length > 0) {
          let data = customerList.value.filter((item) => item.value == type);
          if (data && data.length > 0) {
            text = data[0].label;
          }
        }
        return text;
      },
    },
    {
      attrs: {
        label: "版本号",
        prop: "version",
        width: 120,
      },
    },
    {
      attrs: {
        label: "合同金额",
        slot: "amount",
        width: 140,
      },
    },
    {
      attrs: {
        label: "已到账金额",
        slot: "refundMoney",
        width: 140,
      },
    },
    {
      attrs: {
        label: "业务员",
        prop: "createUser",
        width: 140,
      },
      render(type) {
        return proxy.dictValueLabel(type, userList.value);
      },
    },
    {
      attrs: {
        label: "创建时间",
        prop: "createTime",
        width: 160,
      },
    },
    {
      attrs: {
        label: "审批状态",
        prop: "status",
        width: 140,
      },
      render(type) {
        let text = "";
        if (status.value && status.value.length > 0) {
          let data = status.value.filter((item) => item.value == type);
          if (data && data.length > 0) {
            text = data[0].label;
          }
        }
        return text;
      },
    },
    {
      attrs: {
        label: "到款状态",
        prop: "refundStatusNew",
        width: 140,
      },
      render(type) {
        let text = "";
        if (refundStatusNew.value && refundStatusNew.value.length > 0) {
          let data = refundStatusNew.value.filter((item) => item.value == type);
          if (data && data.length > 0) {
            text = data[0].label;
          }
        }
        return text;
      },
    },
    {
      attrs: {
        label: "操作",
        width: "120",
        align: "center",
        fixed: "right",
      },
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "打印",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              clickPrint(row);
            },
          },
          {
            attrs: {
              label: "作废",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              ElMessageBox.confirm("此操作将永久删除该数据, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
              }).then(() => {
                proxy
                  .post("/contract/edit", {
                    id: row.id,
                    status: 88,
                  })
                  .then(() => {
                    ElMessage({
                      message: "作废成功",
                      type: "success",
                    });
                    getList();
                  });
              });
            },
          },
        ];
      },
    },
  ];
});
const getDict = () => {
  proxy
    .post("/dictTenantData/page", {
      pageNum: 1,
      pageSize: 999,
      dictCode: "contract_type",
      tenantId: useUserStore().user.tenantId,
    })
    .then((res) => {
      if (res.rows && res.rows.length > 0) {
        contractType.value = res.rows.map((item) => {
          return {
            label: item.dictValue,
            value: item.dictKey,
          };
        });
      }
    });
  proxy
    .post("/dictTenantData/page", {
      pageNum: 1,
      pageSize: 999,
      dictCode: "account_currency",
      tenantId: useUserStore().user.tenantId,
    })
    .then((res) => {
      if (res.rows && res.rows.length > 0) {
        accountCurrency.value = res.rows.map((item) => {
          return {
            label: item.dictValue,
            value: item.dictKey,
          };
        });
      }
    });
  proxy
    .post("/dictTenantData/page", {
      pageNum: 1,
      pageSize: 999,
      dictCode: "trade_methods",
      tenantId: useUserStore().user.tenantId,
    })
    .then((res) => {
      if (res.rows && res.rows.length > 0) {
        tradeMethods.value = res.rows.map((item) => {
          return {
            label: item.dictValue,
            value: item.dictKey,
          };
        });
      }
    });
  proxy.post("/corporation/page", { pageNum: 1, pageSize: 999 }).then((res) => {
    corporationList.value = res.rows.map((item) => {
      return {
        ...item,
        label: item.name,
        value: item.id,
      };
    });
  });
  proxy.post("/customer/page", { pageNum: 1, pageSize: 999 }).then((res) => {
    customerList.value = res.rows.map((item) => {
      return {
        ...item,
        label: item.name,
        value: item.id,
      };
    });
  });
  proxy
    .post("/dictTenantData/page", {
      pageNum: 1,
      pageSize: 999,
      dictCode: "shipping_method",
      tenantId: useUserStore().user.tenantId,
    })
    .then((res) => {
      if (res.rows && res.rows.length > 0) {
        shippingMethod.value = res.rows.map((item) => {
          return {
            label: item.dictValue,
            value: item.dictKey,
          };
        });
      }
    });
  proxy
    .get("/tenantUser/list", {
      pageNum: 1,
      pageSize: 10000,
      tenantId: useUserStore().user.tenantId,
    })
    .then((res) => {
      userList.value = res.rows.map((item) => {
        return {
          label: item.nickName,
          value: item.userId,
        };
      });
    });
};
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy.post("/contract/page", sourceList.value.pagination).then((res) => {
    sourceList.value.data = res.rows;
    sourceList.value.pagination.total = res.total;
    setTimeout(() => {
      loading.value = false;
    }, 200);
  });
};
getDict();
getList();
const newContract = () => {
  proxy.$router.replace({
    path: "/platform_manage/process/processApproval",
    query: {
      flowKey: "contract_flow",
      flowName: "销售合同审批流程",
      random: proxy.random(),
    },
  });
};
const openPrint = ref(false);
const printDetails = ref({});
const clickPrint = (row) => {
  printDetails.value = {};
  openPrint.value = true;
  proxy.post("/contract/getContractPdfInfo", { id: row.id }).then((res) => {
    printDetails.value = res;
  });
};
const clickDownload = () => {
  proxy.getPdf("外销合同PDF文件");
};
const statistics = (label, index) => {
  let num = 0;
  if (printDetails.value.productInfoList && printDetails.value.productInfoList.length > 0) {
    printDetails.value.productInfoList.map((item) => {
      if (item[label]) {
        num = parseFloat(Number(num) + Number(item[label])).toFixed(index);
      }
    });
  }
  return num;
};
const statisticsTwo = (label, index) => {
  let num = 0;
  if (printDetails.value.contractProjectList && printDetails.value.contractProjectList.length > 0) {
    printDetails.value.contractProjectList.map((item) => {
      if (item[label]) {
        num = parseFloat(Number(num) + Number(item[label])).toFixed(index);
      }
    });
  }
  return num;
};
</script>

<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
::v-deep(.el-input-number .el-input__inner) {
  text-align: left;
}
.baseRow {
  min-height: 24px;
  border-top: 1px solid black;
  border-left: 1px solid black;
}
.contentRow {
  border-right: 1px solid black;
  line-height: 24px;
  padding-left: 4px;
}
</style>
